<?xml version="1.0"?>
<xsl:stylesheet version="3.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java">
	<xsl:output method="xml" encoding="UTF-8" indent="true"/>
	
	<xsl:template match="/sqlMapConfig">
		<xsl:comment>Converted at: <xsl:value-of select="current-dateTime()"/> </xsl:comment>
		<xsl:text disable-output-escaping="yes"><![CDATA[
		<!DOCTYPE configuration PUBLIC "-//mybatis.org//DTD SQL Map Config 3.0//EN"
		"http://mybatis.org/dtd/mybatis-3-config.dtd">
		]]></xsl:text>

		<xsl:element name="configuration">
			<xsl:apply-templates select="/sqlMapConfig/settings"/>
			<xsl:text>
	</xsl:text>
			<xsl:element name="typeAliases">
				<xsl:text>
		</xsl:text>
				<xsl:for-each select="/sqlMapConfig/typeAlias">
					<xsl:copy-of select="."/>
					<xsl:text>
			</xsl:text>
				</xsl:for-each>
			</xsl:element>
			<xsl:text>
	
	</xsl:text>
			<xsl:element name="typeHandlers">
				<xsl:text>
		</xsl:text>
				<xsl:for-each select="/sqlMapConfig/typeHandler">
					<xsl:element name="typeHandler">
						<xsl:attribute name="javaType">
							<xsl:value-of select="@javaType"/>
						</xsl:attribute>
						<xsl:attribute name="jdbcType">
							<xsl:value-of select="@jdbcType"/>
						</xsl:attribute>
						<xsl:attribute name="handler">
							<xsl:value-of select="@callback"/>
						</xsl:attribute>
					</xsl:element>
					<xsl:text>
			</xsl:text>
				</xsl:for-each>
			</xsl:element>
			<xsl:text>
	
	</xsl:text>

			<xsl:if test="resultObjectFactory">
				<xsl:element name="objectFactory">
					<xsl:attribute name="type">
						<xsl:value-of select="resultObjectFactory/@type"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
		
		</xsl:text>
			</xsl:if>

			<xsl:if test="transactionManager">
				<xsl:element name="environments">
					<xsl:attribute name="default">default</xsl:attribute>
					<xsl:text>
		</xsl:text>
					<xsl:element name="environment">
						<xsl:attribute name="id">default</xsl:attribute>
						<xsl:text>
			</xsl:text>
						<xsl:element name="transactionManager">
							<xsl:attribute name="type">
								<xsl:value-of select="transactionManager/@type"/>
							</xsl:attribute>
							<xsl:for-each select="transactionManager/property">
								<xsl:text>
					</xsl:text>
								<xsl:copy-of select="."/>
							</xsl:for-each>
							<xsl:text>
				</xsl:text>
						</xsl:element>
						<xsl:text>
			</xsl:text>
						<xsl:if test="transactionManager/dataSource">
							<xsl:text>
				</xsl:text>
							<xsl:element name="dataSource">
								<xsl:attribute name="type">
									<xsl:value-of select="transactionManager/dataSource/@type"/>
								</xsl:attribute>
								<xsl:for-each select="transactionManager/dataSource/property">
									<xsl:text>
						</xsl:text>
									<xsl:copy-of select="."/>
								</xsl:for-each>
								<xsl:text>
					</xsl:text>
							</xsl:element>
							<xsl:text>
				</xsl:text>
						</xsl:if>
					</xsl:element>
					<xsl:text>
		</xsl:text>
				</xsl:element>
				<xsl:text>
	
	</xsl:text>
			</xsl:if>

			<xsl:element name="mappers">
				<xsl:text>
		</xsl:text>
				<xsl:for-each select="/sqlMapConfig/sqlMap">
					<xsl:element name="mapper">
						<xsl:copy-of select="@*"/>
					</xsl:element>
					<xsl:text>
			</xsl:text>
				</xsl:for-each>
			</xsl:element>
			<xsl:text>
	</xsl:text>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMapConfig/settings">
		<xsl:element name="settings">
			<xsl:text>
            </xsl:text>
			<xsl:if test="@cacheModelsEnabled">
				<xsl:element name="setting">
					<xsl:attribute name="name">cacheEnabled</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:value-of select="@cacheModelsEnabled"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
			<xsl:if test="@statementCachingEnabled = 'true'">
				<xsl:element name="setting">
					<xsl:attribute name="name">defaultExecutorType</xsl:attribute>
					<xsl:attribute name="value">REUSE</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
			<xsl:if test="@lazyLoadingEnabled">
				<xsl:element name="setting">
					<xsl:attribute name="name">lazyLoadingEnabled</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:value-of select="@lazyLoadingEnabled"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
			<xsl:if test="@defaultStatementTimeout">
				<xsl:element name="setting">
					<xsl:attribute name="name">defaultStatementTimeout</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:value-of select="@defaultStatementTimeout"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
			<xsl:if test="@forceMultipleResultSetSupport">
				<xsl:element name="setting">
					<xsl:attribute name="name">multipleResultSetsEnabled</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:value-of select="@forceMultipleResultSetSupport"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
			<xsl:if test="@useColumnLabel">
				<xsl:element name="setting">
					<xsl:attribute name="name">useColumnLabel</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:value-of select="@useColumnLabel"/>
					</xsl:attribute>
				</xsl:element>
				<xsl:text>
			</xsl:text>
			</xsl:if>
		</xsl:element>
	</xsl:template>






	<xsl:template match="/sqlMap">
		<xsl:comment>Converted at: <xsl:value-of select="current-dateTime()"/> </xsl:comment>
		<xsl:text disable-output-escaping="yes"><![CDATA[
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" 
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
]]></xsl:text>
		<xsl:element name="mapper">
			<xsl:attribute name="namespace">
				<xsl:value-of select="@namespace"/>
			</xsl:attribute>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/select">
		<xsl:element name="select">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@parameterClass">
				<xsl:attribute name="parameterType">
					<xsl:value-of select="@parameterClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@parameterMap">
				<xsl:attribute name="parameterMap">
					<xsl:value-of select="@parameterMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@resultClass">
				<xsl:attribute name="resultType">
					<xsl:value-of select="@resultClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@resultMap">
				<xsl:attribute name="resultMap">
					<xsl:value-of select="@resultMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@fetchSize">
				<xsl:attribute name="fetchSize">
					<xsl:value-of select="@fetchSize"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@resultSetType">
				<xsl:attribute name="resultSetType">
					<xsl:value-of select="@resultSetType"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@timeout">
				<xsl:attribute name="timeout">
					<xsl:value-of select="@timeout"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/insert">
		<xsl:element name="insert">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@parameterClass">
				<xsl:attribute name="parameterType">
					<xsl:value-of select="@parameterClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@parameterMap">
				<xsl:attribute name="parameterMap">
					<xsl:value-of select="@parameterMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/update">
		<xsl:element name="update">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@parameterClass">
				<xsl:attribute name="parameterType">
					<xsl:value-of select="@parameterClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@parameterMap">
				<xsl:attribute name="parameterMap">
					<xsl:value-of select="@parameterMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/procedure">
		<xsl:element name="update">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@parameterClass">
				<xsl:attribute name="parameterType">
					<xsl:value-of select="@parameterClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@parameterMap">
				<xsl:attribute name="parameterMap">
					<xsl:value-of select="@parameterMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="statementType">CALLABLE</xsl:attribute>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/delete">
		<xsl:element name="delete">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@parameterClass">
				<xsl:attribute name="parameterType">
					<xsl:value-of select="@parameterClass"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@parameterMap">
				<xsl:attribute name="parameterMap">
					<xsl:value-of select="@parameterMap"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/resultMap">
		<xsl:element name="resultMap">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@class">
				<xsl:attribute name="type">
					<xsl:value-of select="@class"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@extends">
				<xsl:attribute name="extends">
					<xsl:value-of select="@extends"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/resultMap/discriminator">
		<xsl:element name="discriminator">
			<xsl:attribute name="javaType">
				<xsl:value-of select="@javaType"/>
			</xsl:attribute>
			<xsl:if test="@column">
				<xsl:attribute name="column">
					<xsl:value-of select="@column"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@jdbcType">
				<xsl:attribute name="jdbcType">
					<xsl:value-of select="@jdbcType"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@typeHandler">
				<xsl:attribute name="typeHandler">
					<xsl:value-of select="@typeHandler"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/resultMap/discriminator/subMap">
		<xsl:element name="case">
			<xsl:attribute name="value">
				<xsl:value-of select="@value"/>
			</xsl:attribute>
			<xsl:attribute name="resultMap">
				<xsl:value-of select="@resultMap"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/parameterMap">
		<xsl:element name="parameterMap">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:if test="@class">
				<xsl:attribute name="type">
					<xsl:value-of select="@class"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>

	<xsl:template match="/sqlMap/parameterMap/parameter">
		<xsl:copy-of select="."/>
	</xsl:template>

	<xsl:template match="/sqlMap/resultMap/result">
		<xsl:if test="@nullValue">
			<xsl:message>Sorry, I can`t migrate nullValue in: <xsl:copy-of select="."
				/></xsl:message>
		</xsl:if>
		<xsl:if test="@columnIndex">
			<xsl:message>Sorry, I can`t migrate columnIndex in: <xsl:copy-of select="."
				/></xsl:message>
		</xsl:if>
		<xsl:if test="@notNullColumn">
			<xsl:message>Sorry, I can`t migrate notNullColumn in: <xsl:copy-of select="."
				/></xsl:message>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="@resultMap">
				<xsl:element name="collection">
					<xsl:attribute name="property">
						<xsl:value-of select="@property"/>
					</xsl:attribute>
					<xsl:attribute name="resultMap">
						<xsl:value-of select="@resultMap"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test="@select">
				<xsl:element name="association">
					<xsl:attribute name="property">
						<xsl:value-of select="@property"/>
					</xsl:attribute>
					<xsl:attribute name="select">
						<xsl:value-of select="@select"/>
					</xsl:attribute>
					<xsl:if test="@column">
						<xsl:attribute name="column">
							<xsl:value-of select="@column"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@javaType">
						<xsl:attribute name="javaType">
							<xsl:value-of select="@javaType"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="result">
					<xsl:if test="@property">
						<xsl:attribute name="property">
							<xsl:value-of select="@property"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="@column">
							<xsl:attribute name="column">
								<xsl:value-of select="@column"/>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="column">
								<xsl:value-of select="@property"/>
							</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:if test="@javaType">
						<xsl:attribute name="javaType">
							<xsl:value-of select="@javaType"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@jdbcType">
						<xsl:attribute name="jdbcType">
							<xsl:value-of select="@jdbcType"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@typeHandler">
						<xsl:attribute name="typeHandler">
							<xsl:value-of select="@typeHandler"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="/sqlMap/sql">
		<xsl:element name="sql">
			<xsl:attribute name="id">
				<xsl:value-of select="@id"/>
			</xsl:attribute>
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
