<?xml version="1.0" encoding="UTF-8"?>
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2"
    xmlns:sqf="http://www.schematron-quickfix.com/validator/process">
    <sch:pattern id="shipping-order-validation-company" abstract="true">
        <sch:rule context="Company">
            <sch:assert test="name">Company must have a name.</sch:assert>
            <sch:assert test="subscription-fee &lt;= 5 or subscription-fee &lt;= 6">Subscription fee must not exceed 5 EUR or 6 USD.</sch:assert>
        </sch:rule>
    </sch:pattern>
    <!--
        Create a shipping order validation check. Each shipping order should adhere to the following requirements:
        -Order Details:
            *Each shipping order must contain a unique ID.
            *It should include the date the order was placed and the estimated arrival date.
            *It should contain the status of the order which is: Order Accepted, Shipping, Order Received.
            *A quantity (multiple units of the same item can be included).
        -Item:
            *A unique item ID.
            *Company name.
            *An image (accepted formats: PNG, WEBP, JPEG).
            *A description of the item.
        -Company:
            *A name.
            *A subscription fee in euros or dollars, not exceeding 5 EUR or 6 USD.
        -Address:
        Orders can include multiple items of the same type in the order.
    -->
</sch:schema>