<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="3.0"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs">
    <xsl:output method="html"/>
    
    <!-- Main template to match the root element -->
    <xsl:template match="/">
        <html>
            <head>
                <title>Cooking Book</title>
            </head>
            <body>
                <h1>Cooking Book</h1>
                <!-- Processing each recipe -->
                <xsl:apply-templates select="cookbook/recipe"/>
            </body>
        </html>
    </xsl:template>
    
    <!-- Generic template for processing recipes -->
    <xsl:template match="recipe">
        <xsl:try>
            <div class="recipe">
                <h2><xsl:value-of select="name"/></h2>
                <p><b>Ingredients:</b></p>
                <ul>
                    <xsl:apply-templates select="ingredients/ingredient"/>
                </ul>
                <p><b>Steps:</b></p>
                <ol>
                    <xsl:apply-templates select="steps/step"/>
                </ol>
            </div>
            <xsl:catch>
                <div class="error">Error processing recipe: <xsl:value-of select="name"/></div>
            </xsl:catch>
        </xsl:try>
    </xsl:template>
    
    <!-- Template for processing ingredients -->
    <xsl:template match="ingredient">
        <li><xsl:value-of select="."/></li>
    </xsl:template>
    
    <!-- Template for processing steps -->
    <xsl:template match="step">
        <li><xsl:value-of select="."/></li>
    </xsl:template>
    
</xsl:stylesheet>