<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs"
    version="3.0">
    <xsl:output indent="true"/>
    
    <!-- Template for processing invoice elements -->
    <xsl:template match="invoice">
        <invoiceReport>
            <xsl:apply-templates select="customer" mode="customerInfo"/>
            <xsl:apply-templates select="total" mode="totalAmount"/>
            <xsl:apply-templates select="items/item" mode="itemList"/>
        </invoiceReport>
    </xsl:template>
    
    <!-- Template for processing receipt elements -->
    <xsl:template match="receipt">
        <receiptReport>
            <xsl:apply-templates select="customer" mode="customerInfo"/>
            <xsl:apply-templates select="total" mode="totalAmount"/>
            <xsl:apply-templates select="items/item" mode="itemList"/>
        </receiptReport>
    </xsl:template>
    
    <!-- Template for processing customer information -->
    <xsl:template match="customer" mode="customerInfo">
        <customerInfo>
            <customerName>
                <xsl:text>Customer:</xsl:text>
                <xsl:value-of select="name"/>
            </customerName>
            <customerID>
                <xsl:value-of select="id"/>
            </customerID>
        </customerInfo>
    </xsl:template>
    
    <!-- Template for processing total amount -->
    <xsl:template match="total" mode="totalAmount">
        <details>
            <totalAmount>
                <xsl:value-of select="."/>
            </totalAmount>
        </details>
    </xsl:template>
    
    <!-- Template for processing item list -->
    <xsl:template match="item" mode="itemList">
        <items>
            <xsl:for-each select=".">
                <item>
                    <name><xsl:value-of select="name"/></name>
                    <price><xsl:value-of select="price"/></price>
                </item>
            </xsl:for-each>
        </items>
    </xsl:template>
    
</xsl:stylesheet>
