<?xml version="1.0"?>
<xsl:stylesheet version="3.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java">
    <xsl:output method="xml" encoding="UTF-8" indent="true"/>
    
    <xsl:template match="/sqlMapConfig">
        <xsl:comment>Converted at: <xsl:value-of select="current-dateTime()"/> </xsl:comment>
        <xsl:text disable-output-escaping="yes"><![CDATA[
		<!DOCTYPE configuration PUBLIC "-//mybatis.org//DTD SQL Map Config 3.0//EN"
		"http://mybatis.org/dtd/mybatis-3-config.dtd">
		]]></xsl:text>
        
        <xsl:element name="configuration">
            <xsl:apply-templates select="/sqlMapConfig/settings"/>
            <xsl:text>
	</xsl:text>
            <xsl:element name="typeAliases">
                <xsl:text>
		</xsl:text>
                <xsl:for-each select="/sqlMapConfig/typeAlias">
                    <xsl:copy-of select="."/>
                    <xsl:text>
			</xsl:text>
                </xsl:for-each>
            </xsl:element>
            <xsl:text>
	
	</xsl:text>
            <xsl:element name="typeHandlers">
                <xsl:text>
		</xsl:text>
                <xsl:for-each select="/sqlMapConfig/typeHandler">
                    <xsl:element name="typeHandler">
                        <xsl:attribute name="javaType">
                            <xsl:value-of select="@javaType"/>
                        </xsl:attribute>
                        <xsl:attribute name="jdbcType">
                            <xsl:value-of select="@jdbcType"/>
                        </xsl:attribute>
                        <xsl:attribute name="handler">
                            <xsl:value-of select="@callback"/>
                        </xsl:attribute>
                    </xsl:element>
                    <xsl:text>
			</xsl:text>
                </xsl:for-each>
            </xsl:element>
            <xsl:text>
	
	</xsl:text>
            
            <xsl:if test="resultObjectFactory">
                <xsl:element name="objectFactory">
                    <xsl:attribute name="type">
                        <xsl:value-of select="resultObjectFactory/@type"/>
                    </xsl:attribute>
                </xsl:element>
                <xsl:text>
		
		</xsl:text>
            </xsl:if>
            
            <xsl:if test="transactionManager">
                <xsl:element name="environments">
                    <xsl:attribute name="default">default</xsl:attribute>
                    <xsl:text>
		</xsl:text>
                    <xsl:element name="environment">
                        <xsl:attribute name="id">default</xsl:attribute>
                        <xsl:text>
			</xsl:text>
                        <xsl:element name="transactionManager">
                            <xsl:attribute name="type">
                                <xsl:value-of select="transactionManager/@type"/>
                            </xsl:attribute>
                            <xsl:for-each select="transactionManager/property">
                                <xsl:text>
					</xsl:text>
                                <xsl:copy-of select="."/>
                            </xsl:for-each>
                            <xsl:text>
				</xsl:text>
                        </xsl:element>
                        <xsl:text>
			</xsl:text>
                        <xsl:if test="transactionManager/dataSource">
                            <xsl:text>
				</xsl:text>
                            <xsl:element name="dataSource">
                                <xsl:attribute name="type">
                                    <xsl:value-of select="transactionManager/dataSource/@type"/>
                                </xsl:attribute>
                                <xsl:for-each select="transactionManager/dataSource/property">
                                    <xsl:text>
						</xsl:text>
                                    <xsl:copy-of select="."/>
                                </xsl:for-each>
                                <xsl:text>
					</xsl:text>
                            </xsl:element>
                            <xsl:text>
				</xsl:text>
                        </xsl:if>
                    </xsl:element>
                    <xsl:text>
		</xsl:text>
                </xsl:element>
                <xsl:text>
	
	</xsl:text>
            </xsl:if>
            
            <xsl:element name="mappers">
                <xsl:text>
		</xsl:text>
                <xsl:for-each select="/sqlMapConfig/sqlMap">
                    <xsl:element name="mapper">
                        <xsl:copy-of select="@*"/>
                    </xsl:element>
                    <xsl:text>
			</xsl:text>
                </xsl:for-each>
            </xsl:element>
            <xsl:text>
	</xsl:text>
        </xsl:element>
    </xsl:template>
    
    
</xsl:stylesheet>
