<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:math="http://www.w3.org/2005/xpath-functions/math"
    exclude-result-prefixes="xs math"
    version="3.0">
    <xsl:output indent="true"></xsl:output>
    <xsl:template name="iconTransform">
        <xsl:param name="iconnumber" select="iconnumber" />
        <xsl:choose>
            <xsl:when test="$iconnumber = '01'">32</xsl:when>
            <xsl:when test="$iconnumber = '02'">34</xsl:when>
            <xsl:when test="$iconnumber = '03'">30</xsl:when>
            <xsl:when test="$iconnumber = '04'">28</xsl:when>
            <xsl:when test="$iconnumber = '05'">28</xsl:when>
            <xsl:when test="$iconnumber = '06'">28</xsl:when>
            <xsl:when test="$iconnumber = '07'">26</xsl:when>
            <xsl:when test="$iconnumber = '08'">26</xsl:when>
            <xsl:when test="$iconnumber = '11'">20</xsl:when>
            <xsl:when test="$iconnumber = '12'">11</xsl:when>
            <xsl:when test="$iconnumber = '13'">39</xsl:when>
            <xsl:when test="$iconnumber = '14'">39</xsl:when>
            <xsl:when test="$iconnumber = '15'">17</xsl:when>
            <xsl:when test="$iconnumber = '16'">38</xsl:when>
            <xsl:when test="$iconnumber = '17'">37</xsl:when>
            <xsl:when test="$iconnumber = '18'">40</xsl:when>
            <xsl:when test="$iconnumber = '19'">15</xsl:when>
            <xsl:when test="$iconnumber = '20'">41</xsl:when>
            <xsl:when test="$iconnumber = '21'">15</xsl:when>
            <xsl:when test="$iconnumber = '22'">18</xsl:when>
            <xsl:when test="$iconnumber = '23'">39</xsl:when>
            <xsl:when test="$iconnumber = '24'">25</xsl:when>
            <xsl:when test="$iconnumber = '25'">18</xsl:when>
            <xsl:when test="$iconnumber = '26'">5</xsl:when>
            <xsl:when test="$iconnumber = '27'">20</xsl:when>
            <xsl:when test="$iconnumber = '29'">7</xsl:when>
            <xsl:when test="$iconnumber = '30'">36</xsl:when>
            <xsl:when test="$iconnumber = '31'">25</xsl:when>
            <xsl:when test="$iconnumber = '32'">23</xsl:when>
            <xsl:when test="$iconnumber = '33'">31</xsl:when>
            <xsl:when test="$iconnumber = '34'">33</xsl:when>
            <xsl:when test="$iconnumber = '35'">29</xsl:when>
            <xsl:when test="$iconnumber = '36'">29</xsl:when>
            <xsl:when test="$iconnumber = '37'">46</xsl:when>
            <xsl:when test="$iconnumber = '38'">27</xsl:when>
            <xsl:when test="$iconnumber = '39'">45</xsl:when>
            <xsl:when test="$iconnumber = '40'">45</xsl:when>
            <xsl:when test="$iconnumber = '41'">47</xsl:when>
            <xsl:when test="$iconnumber = '42'">47</xsl:when>
            <xsl:when test="$iconnumber = '43'">46</xsl:when>
            <xsl:when test="$iconnumber = '44'">45</xsl:when>
        </xsl:choose>
    </xsl:template>
    
    <xsl:template match="weatherData">
        <html>
            <body>
                <xsl:apply-templates select="icon"/>
            </body>
        </html>
    </xsl:template>
    
    <xsl:template match="icon">
        <xsl:variable name="iconnumber" select="iconnumber"/>
        <xsl:variable name="transformedIcon">
            <xsl:call-template name="iconTransform">
                <xsl:with-param name="iconnumber" select="$iconnumber"/>
            </xsl:call-template>
        </xsl:variable>
        <div>
            <xsl:value-of select="$transformedIcon"/>
        </div>
    </xsl:template>
</xsl:stylesheet>