<?xml version="1.0" encoding="UTF-8"?>
<!-- The "map" namespace was added manually-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:math="http://www.w3.org/2005/xpath-functions/math"
    xmlns:map="http://www.w3.org/2005/xpath-functions/map"
    exclude-result-prefixes="xs math map"
    version="3.0">
    
    <xsl:output indent="true"></xsl:output>
    
    <!-- Map for icon transformation -->
    <xsl:variable name="iconMap" as="map(xs:string, xs:integer)">
        <xsl:map>
            <xsl:map-entry key="'01'" select="32"/>
            <xsl:map-entry key="'02'" select="34"/>
            <xsl:map-entry key="'03'" select="30"/>
            <xsl:map-entry key="'04'" select="28"/>
            <xsl:map-entry key="'05'" select="28"/>
            <xsl:map-entry key="'06'" select="28"/>
            <xsl:map-entry key="'07'" select="26"/>
            <xsl:map-entry key="'08'" select="26"/>
            <xsl:map-entry key="'11'" select="20"/>
            <xsl:map-entry key="'12'" select="11"/>
            <xsl:map-entry key="'13'" select="39"/>
            <xsl:map-entry key="'14'" select="39"/>
            <xsl:map-entry key="'15'" select="17"/>
            <xsl:map-entry key="'16'" select="38"/>
            <xsl:map-entry key="'17'" select="37"/>
            <xsl:map-entry key="'18'" select="40"/>
            <xsl:map-entry key="'19'" select="15"/>
            <xsl:map-entry key="'20'" select="41"/>
            <xsl:map-entry key="'21'" select="15"/>
            <xsl:map-entry key="'22'" select="18"/>
            <xsl:map-entry key="'23'" select="39"/>
            <xsl:map-entry key="'24'" select="25"/>
            <xsl:map-entry key="'25'" select="18"/>
            <xsl:map-entry key="'26'" select="5"/>
            <xsl:map-entry key="'27'" select="20"/>
            <xsl:map-entry key="'29'" select="7"/>
            <xsl:map-entry key="'30'" select="36"/>
            <xsl:map-entry key="'31'" select="25"/>
            <xsl:map-entry key="'32'" select="23"/>
            <xsl:map-entry key="'33'" select="31"/>
            <xsl:map-entry key="'34'" select="33"/>
            <xsl:map-entry key="'35'" select="29"/>
            <xsl:map-entry key="'36'" select="29"/>
            <xsl:map-entry key="'37'" select="46"/>
            <xsl:map-entry key="'38'" select="27"/>
            <xsl:map-entry key="'39'" select="45"/>
            <xsl:map-entry key="'40'" select="45"/>
            <xsl:map-entry key="'41'" select="47"/>
            <xsl:map-entry key="'42'" select="47"/>
            <xsl:map-entry key="'43'" select="46"/>
            <xsl:map-entry key="'44'" select="45"/>
        </xsl:map>
    </xsl:variable>
    
    <!-- Template to transform icon number -->
    <xsl:template name="iconTransform">
        <xsl:param name="iconnumber" as="xs:string?" />
        <xsl:try>
            <xsl:variable name="iconValue" select="map:get($iconMap, $iconnumber)" as="xs:integer?" />
            <xsl:sequence select="if ($iconValue) then $iconValue else -1"/>
            <xsl:catch>
                <xsl:sequence select="-1"/>
            </xsl:catch>
        </xsl:try>
    </xsl:template>
    
    <!-- Template to match weatherData and apply icon transformation -->
    <xsl:template match="weatherData">
        <html>
            <body>
                <!-- Apply templates to icon elements -->
                <xsl:apply-templates select="icon"/>
            </body>
        </html>
    </xsl:template>
    
    <!-- Template to handle icon elements -->
    <xsl:template match="icon">
        <xsl:variable name="iconnumber" select="iconnumber"/>
        <xsl:variable name="transformedIcon">
            <xsl:call-template name="iconTransform">
                <xsl:with-param name="iconnumber" select="$iconnumber"/>
            </xsl:call-template>
        </xsl:variable>
        <div>
            <xsl:value-of select="$transformedIcon"/>
        </div>
    </xsl:template>
    
    
</xsl:stylesheet>
