<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html" version="5.0" encoding="UTF-8" indent="yes"/>
    <xsl:template match="/">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <title><xsl:value-of select="/rss/channel/title"/> RSS Feed</title>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
            </head>
            <body>
                <div id="content">
                    <p class="explanation">
                        <!--
                        This is a podcast RSS feed generated by <a href="http://www.seriouslysimplepodcasting.com/" target="_blank">Seriously Simple Podcasting</a>. It is meant for consumption by podcast feed readers using the URL in the address bar.
                    -->
                    </p>
                    <div id="channel-header">
                        <h1>
                            <xsl:if test="/rss/channel/image">
                                <div id="channel-image">
                                    <a>
                                        <xsl:attribute name="href">
                                            <xsl:value-of select="/rss/channel/image/link"/>
                                        </xsl:attribute>
                                        <img>
                                            <xsl:attribute name="src">
                                                <xsl:value-of select="/rss/channel/image/url"/>
                                            </xsl:attribute>
                                            <xsl:attribute name="title">
                                                <xsl:value-of select="/rss/channel/image/title"/>
                                            </xsl:attribute>
                                        </img>
                                    </a>
                                </div>
                            </xsl:if>
                            <xsl:value-of select="/rss/channel/title"/>
                        </h1>
                        <p>
                            <xsl:value-of select="/rss/channel/description"/>
                        </p>
                        <p>
                            <a>
                                <xsl:attribute name="href">
                                    <xsl:value-of select="/rss/channel/link"/>
                                </xsl:attribute>
                                <xsl:attribute name="target">_blank</xsl:attribute> Visit podcast
                                website &#x0226B; </a>
                        </p>
                    </div>
                    <xsl:for-each select="/rss/channel/item">
                        <div class="channel-item">
                            <h2>
                                <a>
                                    <xsl:attribute name="href">
                                        <xsl:value-of select="link"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="target">_blank</xsl:attribute>
                                    <xsl:value-of select="title"/>
                                </a>
                            </h2>
                            <xsl:if test="description">
                                <p>
                                    <xsl:value-of select="description" disable-output-escaping="yes"
                                    /> (<xsl:value-of select="pubDate"/>) </p>
                            </xsl:if>
                            <p class="episode_meta">
                                <a>
                                    <xsl:attribute name="href">
                                        <xsl:value-of select="enclosure/@url"/>?ref=download
                                    </xsl:attribute> Download episode </a> | <a>
                                    <xsl:attribute name="href">
                                        <xsl:value-of select="enclosure/@url"/>?ref=new_window </xsl:attribute>
                                    <xsl:attribute name="target">_blank</xsl:attribute> Play in new
                                    window </a> | File size: <xsl:value-of
                                    select='format-number(number(enclosure/@length) div 1024000, "0.0")'
                                />MB </p>
                        </div>
                    </xsl:for-each>
                </div>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>
