<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="3.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html" indent="yes" />

    <xsl:template match="/">
        <html>
            <head>
                <title>Personnel Directory</title>
            </head>
            <body>
                <h1>Personnel Directory</h1>
                <table border="1">
                    <thead>
                        <tr>
                            <th>Photo</th>
                            <th>Name</th>
                            <th>Email</th>
                            <th>Profile Link</th>
                        </tr>
                    </thead>
                    <tbody>
                        <xsl:for-each select="personnel/person">
                            <tr>
                                <td>
                                    <img>
                                        <xsl:attribute name="src">
                                            <xsl:value-of select="@photo" />
                                        </xsl:attribute>
                                        <xsl:attribute name="alt">
                                            <xsl:value-of select="concat(name/given, ' ', name/family)" />
                                        </xsl:attribute>
                                    </img>
                                </td>
                                <td>
                                    <xsl:value-of select="concat(name/given, ' ', name/family)" />
                                </td>
                                <td>
                                    <a>
                                        <xsl:attribute name="href">
                                            <xsl:value-of select="concat('mailto:', email)" />
                                        </xsl:attribute>
                                        <xsl:value-of select="email" />
                                    </a>
                                </td>
                                <td>
                                    <a>
                                        <xsl:attribute name="href">
                                            <xsl:value-of select="url/@href" />
                                        </xsl:attribute>
                                        Profile
                                    </a>
                                </td>
                            </tr>
                        </xsl:for-each>
                    </tbody>
                </table>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>
