<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="3.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:p="http://www.oxygenxml.com/ns/samples/personal" 
    exclude-result-prefixes="p">
    
    <!-- Root Template -->
    <xsl:template match="/">
        <html>
            <head>
                <title>Employees</title>
                <style type="text/css">
                    body {
                    font-family: Helvetica, Arial, sans-serif;
                    }
                    .header {
                    color: #FFFFFF;
                    background-color: #336666;
                    text-align: center;
                    }
                </style>
            </head>
            <body>
                <table border="1">
                    <tr class="header">
                        <th>Name</th>
                        <th>Email</th>
                        <th>Link</th>
                    </tr>
                    <xsl:apply-templates select="//p:person"/>
                </table>
            </body>
        </html>
    </xsl:template>
    
    <!-- Template for Person -->
    <xsl:template match="p:person">
        <tr align="center">
            <td width="120">
                <span style="font-family: Verdana; font-size: 14px; font-style: italic;">
                    <xsl:value-of select="concat(p:name/p:family, ' ', p:name/p:given)"/>
                </span>
            </td>
            <td width="120">
                <span style="font-family: Verdana; font-size: 14px;">
                    <xsl:value-of select="p:email"/>
                </span>
            </td>
            <td>
                <span style="font-family: Verdana; font-size: 14px; color: black;">
                    <xsl:value-of select="string-join((p:link/@subordinates, p:link/@manager), ', ')"/>
                </span>
            </td>
        </tr>
    </xsl:template>
    
</xsl:stylesheet>